//+------------------------------------------------------------------+
//|                                    FerruFx_Trend+_EA_reverse.mq4 |
//|                                        Copyright  2007, FerruFx |
//|                                                                  |
//+------------------------------------------------------------------+


//---- Trade parameters
extern string    Trade_parameters = "=== Trade parameters ===";
extern double    Lot              =          1.0;  // Lot size
extern double    TakeProfit       =        100.0;  // Profit for the order opened
extern double    TrailingStop     =          0.0;  // Pips to trail the StopLoss
extern double    StopLoss         =        100.0;  // StopLoss
extern int       Slippage         =            2;  // Slippage
extern double    LevelOpenBuy     =         75.0;  // Trend level to reach to start to trade
extern double    LevelOpenSell    =         75.0;  // Trend level to reach to start to trade

//---- Money management
extern string    Money_management = "=== Money management ===";
extern bool      ManagedLotSize   =         true;  // If true, lot size based on the free margin
extern double    Risk             =          1.0;  // Risk to protect the equity
extern int       MaxLot           =         10.0;  // Maximum lot size

//---- Indicators to calculate the trend
extern string    Trend_calculation     = "=== Trend calculation and display ===";
extern bool      display_fast_MA       =     true;
extern bool      display_medium_MA     =     true;
extern bool      display_slow_MA       =     true;
extern bool      display_CCI           =     true;
extern bool      display_MACD          =     true;
extern bool      display_ADX           =     true;
extern bool      display_BULLS         =     true;
extern bool      display_BEARS         =     true;
extern bool      display_STOCH         =     true;
extern bool      display_RSI           =     true;
extern bool      display_FORCE         =     true;
extern bool      display_MOMENTUM      =     true;
extern bool      display_DeMARKER      =     true;
extern bool      display_WAE           =     true;

//---- Timeframes to calculate the trend
extern string    TF_calculation        = "=== If display false, set coef to 0 ===";
extern string    Coefs_TF              = "3 TF true, SUM of their coef must be 3";
extern bool      display_M1            =     true;
extern double    coef_m1               =      1.0;
extern bool      display_M5            =     true;
extern double    coef_m5               =      1.0;
extern bool      display_M15           =     true;
extern double    coef_m15              =      1.0;
extern bool      display_M30           =     true;
extern double    coef_m30              =      1.0;
extern bool      display_H1            =     true;
extern double    coef_H1               =      1.0;
extern bool      display_H4            =     true;
extern double    coef_H4               =      1.0;
extern bool      display_D1            =     true;
extern double    coef_D1               =      1.0;

datetime timeprev = 0;
double   sl, tp, lot;
int      MagicNumber, cnt, ticket, total;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   if (Symbol() == "AUDCADm" || Symbol() == "AUDCAD") { MagicNumber = 426701; }
   if (Symbol() == "AUDJPYm" || Symbol() == "AUDJPY") { MagicNumber = 426702; }
   if (Symbol() == "AUDNZDm" || Symbol() == "AUDNZD") { MagicNumber = 426703; }
   if (Symbol() == "AUDUSDm" || Symbol() == "AUDUSD") { MagicNumber = 426704; }
   if (Symbol() == "CHFJPYm" || Symbol() == "CHFJPY") { MagicNumber = 426705; }
   if (Symbol() == "EURAUDm" || Symbol() == "EURAUD") { MagicNumber = 426706; }
   if (Symbol() == "EURCADm" || Symbol() == "EURCAD") { MagicNumber = 426707; }
   if (Symbol() == "EURCHFm" || Symbol() == "EURCHF") { MagicNumber = 426708; }
   if (Symbol() == "EURGBPm" || Symbol() == "EURGBP") { MagicNumber = 426709; }
   if (Symbol() == "EURJPYm" || Symbol() == "EURJPY") { MagicNumber = 426710; }
   if (Symbol() == "EURUSDm" || Symbol() == "EURUSD") { MagicNumber = 426711; }
   if (Symbol() == "GBPCHFm" || Symbol() == "GBPCHF") { MagicNumber = 426712; }
   if (Symbol() == "GBPJPYm" || Symbol() == "GBPJPY") { MagicNumber = 426713; }
   if (Symbol() == "GBPUSDm" || Symbol() == "GBPUSD") { MagicNumber = 426714; }
   if (Symbol() == "NZDJPYm" || Symbol() == "NZDJPY") { MagicNumber = 426715; }
   if (Symbol() == "NZDUSDm" || Symbol() == "NZDUSD") { MagicNumber = 426716; }
   if (Symbol() == "USDCHFm" || Symbol() == "USDCHF") { MagicNumber = 426717; }
   if (Symbol() == "USDJPYm" || Symbol() == "USDJPY") { MagicNumber = 426718; }
   if (Symbol() == "USDCADm" || Symbol() == "USDCAD") { MagicNumber = 426719; }
   if (MagicNumber == 0) { MagicNumber = 426799; }
   return (0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   
//---- First tick of a new canddle

   if ( timeprev == Time[0] ) { return(0); }   //---- not the first tick :: exit
   timeprev = Time[0];
   
//---- Calculation of the trend
   
   double trend_up = iCustom(NULL,0,"FerruFx_Trend+","=== Trade Info Box ===",false,10,20,"=== Trend Box ===",false,170,20,"=== Trade Info ===",true,5,0.832,75,"=== Trend calculation and display ===",display_fast_MA,display_medium_MA,display_slow_MA,display_CCI,display_MACD,display_ADX,display_BULLS,display_BEARS,display_STOCH,display_RSI,display_FORCE,display_MOMENTUM,display_DeMARKER,display_WAE,"=== If display false, set coef to 0 ===","3 TF true, SUM of their coef must be 3",display_M1,coef_m1,display_M5,coef_m5,display_M15,coef_m15,display_M30,coef_m30,display_H1,coef_H1,display_H4,coef_H4,display_D1,coef_D1,"=== Format: 2007.05.02 00:00 ===",D'2007.05.03 00:00',0,false,0,0);

   double trend_down = iCustom(NULL,0,"FerruFx_Trend+","=== Trade Info Box ===",false,10,20,"=== Trend Box ===",false,170,20,"=== Trade Info ===",true,5,0.832,75,"=== Trend calculation and display ===",display_fast_MA,display_medium_MA,display_slow_MA,display_CCI,display_MACD,display_ADX,display_BULLS,display_BEARS,display_STOCH,display_RSI,display_FORCE,display_MOMENTUM,display_DeMARKER,display_WAE,"=== If display false, set coef to 0 ===","3 TF true, SUM of their coef must be 3",display_M1,coef_m1,display_M5,coef_m5,display_M15,coef_m15,display_M30,coef_m30,display_H1,coef_H1,display_H4,coef_H4,display_D1,coef_D1,"=== Format: 2007.05.02 00:00 ===",D'2007.05.03 00:00',0,false,1,0);

/*
//---- Test the variables from iCustom
   
   ObjectCreate("up01", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("up01",DoubleToStr(trend_up,0),7, "Verdana", Lime);
   ObjectSet("up01", OBJPROP_CORNER, 1);
   ObjectSet("up01", OBJPROP_XDISTANCE, 200);
   ObjectSet("up01", OBJPROP_YDISTANCE, 50);
   
   ObjectCreate("down01", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("down01",DoubleToStr(trend_down,0),7, "Verdana", Red);
   ObjectSet("down01", OBJPROP_CORNER, 1);
   ObjectSet("down01", OBJPROP_XDISTANCE, 200);
   ObjectSet("down01", OBJPROP_YDISTANCE, 70);
*/

//---- Check if order opened
   
   total = OrdersTotal();
   if ( total < 1 )    //---- we can go trading
   {

//---- Lot size calculation
 
    if ( ManagedLotSize )
    {
     lot = ( AccountFreeMargin() * Risk ) / 1000;
     if ( lot > MaxLot ) { lot = MaxLot; }
    }
    else { lot = Lot; }

//---- Check for long position
   
    if ( trend_down >= LevelOpenBuy )
    {
     if (TakeProfit==0) { tp=0; }
     else { tp=Ask+TakeProfit*Point; }
     if (StopLoss==0) { sl=0; }
     else { sl=Ask-StopLoss*Point; }
     ticket=OrderSend(Symbol(),OP_BUY,lot,Ask,Slippage,sl,tp,"FerruFx_Trend+_reverse",MagicNumber,0,Lime);
     if( ticket > 0 )
     {
      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
      {
       Print("BUY order opened : ",OrderOpenPrice());
      }
     }
     else
     {
      Print("Error opening BUY order : ",GetLastError()); 
     }
     return(0); 
    }

//---- Check for short position

     if ( trend_up > LevelOpenSell ) 
     {
      if (TakeProfit==0) { tp=0; }
      else { tp=Bid-TakeProfit*Point; }
      if (StopLoss==0) { sl=0; }
      else { sl=Bid+StopLoss*Point; }
      ticket=OrderSend(Symbol(),OP_SELL,lot,Bid,3,sl,tp,"FerruFx_Trend+_reverse",MagicNumber,0,Red);
      if(ticket>0)
      {
       if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
       {
        Print("SELL order opened : ",OrderOpenPrice());
       }
      }
      else
      {
       Print("Error opening SELL order : ",GetLastError());
      } 
      return(0); 
     }
     return(0);
     
    }   //---- if (total<1 &&
    
//---- Check trade conditions for close

   if ( trend_down > LevelOpenSell ) { CloseLongs(); }  //---- Exit long
      
   if ( trend_up >= LevelOpenBuy ) { CloseShorts(); }    //---- Exit short
     
//---- Check for trailing

   TrailingLong( TrailingStop );
   TrailingShort( TrailingStop );
   
}   //---- int start()

//+------------------------------------------------------------------+
//| Close long                                                       |
//+------------------------------------------------------------------+
void CloseLongs()
{
 int trades = OrdersTotal();
 for( int trade=0; trade < trades; trade++ )
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  if( OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber )
  {
   continue;
  }
  if( OrderType() == OP_BUY )
  {
  OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);
  }
 }   //---- for
}

//+------------------------------------------------------------------+
//| Close short                                                      |
//+------------------------------------------------------------------+
void CloseShorts()
{
 int trades = OrdersTotal();
 for( int trade=0; trade < trades; trade++ )
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  if( OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber )
  {
   continue;
  }
  if( OrderType() == OP_SELL )
  {
   OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Pink);
  }
 }   //---- for
}

//+------------------------------------------------------------------+
//| Trailing long                                                    |
//+------------------------------------------------------------------+
void TrailingLong(int stop)
{
 if( stop == 0 ) return;
 
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES)) continue;
  if( OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber ) continue;
  if( OrderType() == OP_BUY )
  {            
   if(( Bid - OrderOpenPrice() ) > ( Point * stop ))
   {
    if(( OrderStopLoss() < ( Bid - Point * stop )) || ( OrderStopLoss() == 0 ))
    {
     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*stop,OrderTakeProfit(),0,Lime);
    }
   }
  }
 }   //---- for
}    //---- void

//+------------------------------------------------------------------+
//| Trailing short                                                   |
//+------------------------------------------------------------------+
void TrailingShort(int stop)
{
 if( stop == 0 ) return;
 
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES)) continue;
  if( OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber ) continue;
  if( OrderType() == OP_SELL )
  {
   if(( OrderOpenPrice() - Ask ) > ( Point * stop ))
   {
    if(( OrderStopLoss() > ( Ask + Point * stop )) || ( OrderStopLoss() == 0 ))
    {
     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*stop,OrderTakeProfit(),0,Pink);
    }
   }
  }
 }   //---- for
}    //---- void